//=============================================================================
// UGHstats
// (public class)
// by }TCP{Wolf aka Mia_The_Chaotic
// Version: 0.01 - 2006/03/21
//
// Usage:
// Unreal.exe [map]?game=UTeamFix.[gamemode]?mutator=UGH.UGHstats -server [etc...]
//
// Compilation dependencies:
// EditPackages=Core
// EditPackages=Engine
// EditPackages=UBrowser
// EditPackages=UnrealShare
// EditPackages=UnrealI
// EditPackages=IpServer
// EditPackages=UTF_Resources
// EditPackages=UTeamFix
// EditPackages=UTF_CustomProjectiles
// EditPackages=UTF_Pawns
// EditPackages=UTF_Items
// EditPackages=UTF_GUI
// EditPackages=UGH
// ============================================================================
//
// Yea thats's right... me doing a stats mutator, I guess you didn't expect to
// live long enough to see that happen... guess what: ME NEITHER!
//
// I'm afraid the only way to collect decent stats is using more events than
// normal Unreal has to offer (as seen in UTstats and UT2k3/4 stats), so...
// EXCUSE ME if this is a UTF mutator and not a normal one (I am so sorry...
// no... I'm kidding, I'm not! :P)
//
// Anyway...
//
// Let's keep this brief... I never liked stats, I never cared for them at all.
// But... somebody special said it might help keep Unreal alive, so I am hereby
// delivering a base onto which people can program their "stats collectors and
// database/evaluation" or whatever-other-crap-you-can-think-of program to build
// on...
//
// This mutator sends a bunch of infos to a dedicated server. So you need to
// run a stats server to collect them - yea... somebody needs to write a stats
// server and it won't be me! No certainly not! I said no didn't I? Well...
// still with this mutator I deliver along a JAVA program (precompiled for your
// testing pleasure) to receive this mutators text messages (yea it's all
// plaintext - w00t) and it will be written on the system console!
//
// THIS IS MEANT AS DEMONSTRATION HOW IT MAY WORK!
// WARNING: The amount of data needs to be kept small! Unreal is ill suited to
// maintain continuous TCP network connections with a shitload of data securely
// connected all the time. So... I just send a limited amount of data at the
// end of each map.
// All data is plaintext, but you get the "GameSpy" protocol key/value
// communication strategy (meaing "\key\value\" pairs).
// GO AND WRITE AN APPLICATION TO RECEIVE THEM AND EVALUATE THEM!
//
// This mutator and the accompanied java program (netecho.java) is declared
// FREEWARE! Do whatever you want with them, the source will be available at
// all times. Just don't ask me to write anything more :-P Write your own
// evaluation software and database pushers... show what you've got and that
// you do want those ugly stats - :-D
//
// }TCP{Wolf
//=============================================================================
class UGHstats extends UTeamBaseMutator config(UGHstats);

// configuration
var() config String STATSserver;     // the stats server address - PORT IS EXTRA
var() config int STATSserverPort;    // now here goes the port :P
var() config bool bNoEmptyReport;    // set this true if you do NOT want to send a stat report when the
                                     // is empty or when the game had not even started when map switched

// reports - what to query from the server... using UDPQuery results
var() config bool bReportBasic;	// IpServer/UdpServerQuery: Return a string of basic information.
var() config bool bReportUTFadditions;	// Set true to add some more information UTF grabs
var() config bool bReportInfo;	// IpServer/UdpServerQuery: Return a string of important system information.
var() config bool bReportRules;	// IpServer/UdpServerQuery: Return a string of miscellaneous information
							//                          Game specific information, user defined data, custom parameters for the command line.
var() config bool bReportPlayers;	// UTF specific stats about players
var() config bool bReportBots;	// UTF specific stats about computer controlled players
var() config bool bReportSpecs;	// Set false to ignore specs...



// called when game ends - check bgi.bDontRestart for real ends
// "SKIPDAMN" avoids call when final game state is reached (to look at scoreboard)
// which is intercepted by BGI already ** TO CHANGE **
// *** OVERTIME OR AVOIDED GAME ENDS NOT HANDLED YET ***

// Programmer's notes:
// bgi = BaseGameInfo(Level.Game)

function EndGame( string Reason )
{
 local UGHlink link;	// TCP link actor
 local bool bSend;		// yes or no if we actually SEND data at all

 if (Next!=None) Next.EndGame(Reason);

 // LOCAL IMPLEMENTATION BEGIN
 bSend = true; // by default we do send

 // under some circumstances, we may not send data, let us determine them
 if (bNoEmptyReport)
 {
	if (bgi.numplayers == 0)
		bSend = false;	// this means the moment the game ended there are no players...
	if (!bgi.bGameStarted)
		bSend = false; // this means the game had not even BEGUN! This can happen if
					// a UT mode (>simple) is used and not enough players joined to start
					// the game and the time ran out...
 }

 // game has ended, open network connection, put the collected
 // data into text and send it
 if (bSend)
 {
	l("Trying to connect to: "$STATSserver$":"$STATSserverPort);
	link = spawn(class'UGHlink');
	link.port = STATSserverPort;
	link.mut = self;
	link.resolve(STATSserver);
 }

 /* Programmer's note for Smartass coders (not Smartball :P)
    I know I could have written
    if (bNoEmptyReport && ((bgi.numplayers == 0) || !bgi.bGameStarted))
    instead of
    if (bSend)
    with all the extra lines above...
    But...
    I love readable code compared to hieroglyphs :P so go to hell! :P
 */

 // LOCAL IMPLEMENTATION END
}



///////////////////////////////////////////////
// AID

// log function... I am such a lazy writer :P
function l(String what)
{
 log(what,'UGHstats');
}





// NOTES:
// defaults to localhost telnet port (127.0.0.1:23)

defaultproperties
{
 HumanName="UTF stats mutator"

 STATSserver="127.0.0.1"
 STATSserverPort=23

 bReportBasic=true
 bReportInfo=true
 bReportRules=true
 bReportUTFadditions=true
 bReportPlayers=true
 bReportBots=true
 bReportSpecs=true
}
